package com.sun.imageio.plugins.common;

import javax.imageio.ImageTypeSpecifier;
import java.util.ArrayList;
import javax.imageio.metadata.IIOMetadataFormatImpl;

public class StandardMetadataFormat extends IIOMetadataFormatImpl
{
    private void addSingleAttributeElement(String s, String parentName, int dataType) {
        this.addElement(s, parentName, 0);
        this.addAttribute(s, "value", dataType, true, null);
    }
    
    public StandardMetadataFormat() {
        super("javax_imageio_1.0", 2);
        this.addElement("Chroma", "javax_imageio_1.0", 2);
        this.addElement("ColorSpaceType", "Chroma", 0);
        ArrayList<String> enumeratedValues = new ArrayList();
        enumeratedValues.add("XYZ");
        enumeratedValues.add("Lab");
        enumeratedValues.add("Luv");
        enumeratedValues.add("YCbCr");
        enumeratedValues.add("Yxy");
        enumeratedValues.add("YCCK");
        enumeratedValues.add("PhotoYCC");
        enumeratedValues.add("RGB");
        enumeratedValues.add("GRAY");
        enumeratedValues.add("HSV");
        enumeratedValues.add("HLS");
        enumeratedValues.add("CMYK");
        enumeratedValues.add("CMY");
        enumeratedValues.add("2CLR");
        enumeratedValues.add("3CLR");
        enumeratedValues.add("4CLR");
        enumeratedValues.add("5CLR");
        enumeratedValues.add("6CLR");
        enumeratedValues.add("7CLR");
        enumeratedValues.add("8CLR");
        enumeratedValues.add("9CLR");
        enumeratedValues.add("ACLR");
        enumeratedValues.add("BCLR");
        enumeratedValues.add("CCLR");
        enumeratedValues.add("DCLR");
        enumeratedValues.add("ECLR");
        enumeratedValues.add("FCLR");
        this.addAttribute("ColorSpaceType", "name", 0, true, null, enumeratedValues);
        this.addElement("NumChannels", "Chroma", 0);
        this.addAttribute("NumChannels", "value", 2, true, 0, Integer.MAX_VALUE);
        this.addElement("Gamma", "Chroma", 0);
        this.addAttribute("Gamma", "value", 3, true, null);
        this.addElement("BlackIsZero", "Chroma", 0);
        this.addBooleanAttribute("BlackIsZero", "value", true, true);
        this.addElement("Palette", "Chroma", 0, Integer.MAX_VALUE);
        this.addElement("PaletteEntry", "Palette", 0);
        this.addAttribute("PaletteEntry", "index", 2, true, null);
        this.addAttribute("PaletteEntry", "red", 2, true, null);
        this.addAttribute("PaletteEntry", "green", 2, true, null);
        this.addAttribute("PaletteEntry", "blue", 2, true, null);
        this.addAttribute("PaletteEntry", "alpha", 2, false, "255");
        this.addElement("BackgroundIndex", "Chroma", 0);
        this.addAttribute("BackgroundIndex", "value", 2, true, null);
        this.addElement("BackgroundColor", "Chroma", 0);
        this.addAttribute("BackgroundColor", "red", 2, true, null);
        this.addAttribute("BackgroundColor", "green", 2, true, null);
        this.addAttribute("BackgroundColor", "blue", 2, true, null);
        this.addElement("Compression", "javax_imageio_1.0", 2);
        this.addSingleAttributeElement("CompressionTypeName", "Compression", 0);
        this.addElement("Lossless", "Compression", 0);
        this.addBooleanAttribute("Lossless", "value", true, true);
        this.addSingleAttributeElement("NumProgressiveScans", "Compression", 2);
        this.addSingleAttributeElement("BitRate", "Compression", 3);
        this.addElement("Data", "javax_imageio_1.0", 2);
        this.addElement("PlanarConfiguration", "Data", 0);
        ArrayList<String> enumeratedValues2 = new ArrayList();
        enumeratedValues2.add("PixelInterleaved");
        enumeratedValues2.add("PlaneInterleaved");
        enumeratedValues2.add("LineInterleaved");
        enumeratedValues2.add("TileInterleaved");
        this.addAttribute("PlanarConfiguration", "value", 0, true, null, enumeratedValues2);
        this.addElement("SampleFormat", "Data", 0);
        ArrayList<String> enumeratedValues3 = new ArrayList();
        enumeratedValues3.add("SignedIntegral");
        enumeratedValues3.add("UnsignedIntegral");
        enumeratedValues3.add("Real");
        enumeratedValues3.add("Index");
        this.addAttribute("SampleFormat", "value", 0, true, null, enumeratedValues3);
        this.addElement("BitsPerSample", "Data", 0);
        this.addAttribute("BitsPerSample", "value", 2, true, 1, Integer.MAX_VALUE);
        this.addElement("SignificantBitsPerSample", "Data", 0);
        this.addAttribute("SignificantBitsPerSample", "value", 2, true, 1, Integer.MAX_VALUE);
        this.addElement("SampleMSB", "Data", 0);
        this.addAttribute("SampleMSB", "value", 2, true, 1, Integer.MAX_VALUE);
        this.addElement("Dimension", "javax_imageio_1.0", 2);
        this.addSingleAttributeElement("PixelAspectRatio", "Dimension", 3);
        this.addElement("ImageOrientation", "Dimension", 0);
        ArrayList<String> enumeratedValues4 = new ArrayList();
        enumeratedValues4.add("Normal");
        enumeratedValues4.add("Rotate90");
        enumeratedValues4.add("Rotate180");
        enumeratedValues4.add("Rotate270");
        enumeratedValues4.add("FlipH");
        enumeratedValues4.add("FlipV");
        enumeratedValues4.add("FlipHRotate90");
        enumeratedValues4.add("FlipVRotate90");
        this.addAttribute("ImageOrientation", "value", 0, true, null, enumeratedValues4);
        this.addSingleAttributeElement("HorizontalPixelSize", "Dimension", 3);
        this.addSingleAttributeElement("VerticalPixelSize", "Dimension", 3);
        this.addSingleAttributeElement("HorizontalPhysicalPixelSpacing", "Dimension", 3);
        this.addSingleAttributeElement("VerticalPhysicalPixelSpacing", "Dimension", 3);
        this.addSingleAttributeElement("HorizontalPosition", "Dimension", 3);
        this.addSingleAttributeElement("VerticalPosition", "Dimension", 3);
        this.addSingleAttributeElement("HorizontalPixelOffset", "Dimension", 2);
        this.addSingleAttributeElement("VerticalPixelOffset", "Dimension", 2);
        this.addSingleAttributeElement("HorizontalScreenSize", "Dimension", 2);
        this.addSingleAttributeElement("VerticalScreenSize", "Dimension", 2);
        this.addElement("Document", "javax_imageio_1.0", 2);
        this.addElement("FormatVersion", "Document", 0);
        this.addAttribute("FormatVersion", "value", 0, true, null);
        this.addElement("SubimageInterpretation", "Document", 0);
        ArrayList<String> enumeratedValues5 = new ArrayList();
        enumeratedValues5.add("Standalone");
        enumeratedValues5.add("SinglePage");
        enumeratedValues5.add("FullResolution");
        enumeratedValues5.add("ReducedResolution");
        enumeratedValues5.add("PyramidLayer");
        enumeratedValues5.add("Preview");
        enumeratedValues5.add("VolumeSlice");
        enumeratedValues5.add("ObjectView");
        enumeratedValues5.add("Panorama");
        enumeratedValues5.add("AnimationFrame");
        enumeratedValues5.add("TransparencyMask");
        enumeratedValues5.add("CompositingLayer");
        enumeratedValues5.add("SpectralSlice");
        enumeratedValues5.add("Unknown");
        this.addAttribute("SubimageInterpretation", "value", 0, true, null, enumeratedValues5);
        this.addElement("ImageCreationTime", "Document", 0);
        this.addAttribute("ImageCreationTime", "year", 2, true, null);
        this.addAttribute("ImageCreationTime", "month", 2, true, null, "1", "12", true, true);
        this.addAttribute("ImageCreationTime", "day", 2, true, null, "1", "31", true, true);
        this.addAttribute("ImageCreationTime", "hour", 2, false, "0", "0", "23", true, true);
        this.addAttribute("ImageCreationTime", "minute", 2, false, "0", "0", "59", true, true);
        this.addAttribute("ImageCreationTime", "second", 2, false, "0", "0", "60", true, true);
        this.addElement("ImageModificationTime", "Document", 0);
        this.addAttribute("ImageModificationTime", "year", 2, true, null);
        this.addAttribute("ImageModificationTime", "month", 2, true, null, "1", "12", true, true);
        this.addAttribute("ImageModificationTime", "day", 2, true, null, "1", "31", true, true);
        this.addAttribute("ImageModificationTime", "hour", 2, false, "0", "0", "23", true, true);
        this.addAttribute("ImageModificationTime", "minute", 2, false, "0", "0", "59", true, true);
        this.addAttribute("ImageModificationTime", "second", 2, false, "0", "0", "60", true, true);
        this.addElement("Text", "javax_imageio_1.0", 0, Integer.MAX_VALUE);
        this.addElement("TextEntry", "Text", 0);
        this.addAttribute("TextEntry", "keyword", 0, false, null);
        this.addAttribute("TextEntry", "value", 0, true, null);
        this.addAttribute("TextEntry", "language", 0, false, null);
        this.addAttribute("TextEntry", "encoding", 0, false, null);
        ArrayList<String> enumeratedValues6 = new ArrayList();
        enumeratedValues6.add("none");
        enumeratedValues6.add("lzw");
        enumeratedValues6.add("zip");
        enumeratedValues6.add("bzip");
        enumeratedValues6.add("other");
        this.addAttribute("TextEntry", "compression", 0, false, "none", enumeratedValues6);
        this.addElement("Transparency", "javax_imageio_1.0", 2);
        this.addElement("Alpha", "Transparency", 0);
        ArrayList<String> enumeratedValues7 = new ArrayList();
        enumeratedValues7.add("none");
        enumeratedValues7.add("premultiplied");
        enumeratedValues7.add("nonpremultiplied");
        this.addAttribute("Alpha", "value", 0, false, "none", enumeratedValues7);
        this.addSingleAttributeElement("TransparentIndex", "Transparency", 2);
        this.addElement("TransparentColor", "Transparency", 0);
        this.addAttribute("TransparentColor", "value", 2, true, 0, Integer.MAX_VALUE);
        this.addElement("TileTransparencies", "Transparency", 0, Integer.MAX_VALUE);
        this.addElement("TransparentTile", "TileTransparencies", 0);
        this.addAttribute("TransparentTile", "x", 2, true, null);
        this.addAttribute("TransparentTile", "y", 2, true, null);
        this.addElement("TileOpacities", "Transparency", 0, Integer.MAX_VALUE);
        this.addElement("OpaqueTile", "TileOpacities", 0);
        this.addAttribute("OpaqueTile", "x", 2, true, null);
        this.addAttribute("OpaqueTile", "y", 2, true, null);
    }
    
    @Override
    public boolean canNodeAppear(String s, ImageTypeSpecifier imageTypeSpecifier) {
        return true;
    }
}
